/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * HyperTerminal.java
 *
 * Created on 08-oct-2011, 11:13:05
 */
package rs232;

/**
 *
 * @author Jorge
 */

import java.io.File;
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.FileWriter;
import java.io.BufferedWriter;

public class HyperTerminal extends javax.swing.JInternalFrame {
    private static int IDLE=0;
    private static int ESPERANDO_TRANSMITIR_ARCHIVO=1;
    private static int TRANSMITIENDO_ARCHIVO=2;
    private static int ESPERANDO_RECIBIR_ARCHIVO=3;
    private static int RECIBIENDO_ARCHIVO=4;
    private char SOH=(char)1;
    private char ACK=(char)6;
    private char NAK=(char)21;
    private char CAN=(char)24;
    private char EOT=(char)4;
    
    public UART uart;
    public boolean ecoLocal;
    private File archivo;
    private FileReader fr;
    private BufferedReader br;
    private FileWriter fw;
    private BufferedWriter bw;
    private int estado=IDLE;
    
    
    /** Creates new form HyperTerminal */
    public HyperTerminal() {
        initComponents();
    }
    
    public void inicializar(PODRS232 pod){
        uart=new UART(pod,this);  
    }

    public void setVelocidad(int v){
        uart.setVelocidad(v);
    }
    
    public void setBitsDatos(int bitsDatos){
        uart.bitsDatos=bitsDatos;
    }
    
    public void setBitsParo(double bitsParo){
        uart.bitsParo=bitsParo;
    }
    
    public void setParidad(int p){
        uart.paridad=p;
    }
    
    //---------------------------------------------YO
    public void setCtrl_Flujo(boolean cf){
        //uart.setCtrl_Flujo(cf);
        uart.ctrl_flujo=cf;
    }
    //---------------------------------------------YO
    
    public int getVelocidad(){
        return uart.velocidad;
    }
    
    public int getBitsDatos(){
        return uart.bitsDatos;
    }
    
    public double getBitsParo(){
        return uart.bitsParo;
    }
    
    public int getParidad(){
        return uart.paridad;
    }
    
    //---------------------------------------------YO
    public boolean getCtrl_Flujo(){
        return uart.ctrl_flujo;
    }
    //---------------------------------------------YO
    
    private void mostrarComunicaciones(){
        Comunicaciones com=new Comunicaciones(null,true,this);
        com.setVisible(true);
    }
    
    private void mostrarEnviarArchivosTexto(){
        javax.swing.JFileChooser fc=new javax.swing.JFileChooser();
        fc.setFileSelectionMode(javax.swing.JFileChooser.FILES_ONLY);
        int ret=fc.showOpenDialog(null);
        archivo=fc.getSelectedFile();
        if(ret==javax.swing.JFileChooser.APPROVE_OPTION && archivo!=null){
            try{
                fr=new FileReader(archivo);
                br=new BufferedReader(fr);
                estado=ESPERANDO_TRANSMITIR_ARCHIVO;
                uart.enviar(SOH);
            }
            catch(java.io.IOException e){
                System.out.println(e.getMessage());
            }
        }
    }
    
    private void mostrarRecibirArchivosTexto(){
        javax.swing.JFileChooser fc=new javax.swing.JFileChooser();
        fc.setFileSelectionMode(javax.swing.JFileChooser.FILES_ONLY);
        int ret=fc.showOpenDialog(null);
        archivo=fc.getSelectedFile();
        if(ret==javax.swing.JFileChooser.APPROVE_OPTION && archivo!=null){
            try{
                fw=new java.io.FileWriter(archivo);
                bw=new BufferedWriter(fw);
                estado=RECIBIENDO_ARCHIVO;
                uart.enviar(ACK);
            }
            catch(java.io.IOException e){
                System.out.println("Error al escribir archivo :"+e.getMessage());
            }
        }
    }
    
    private void mostrarEnviarArchivoBinario(){
        mostrarEnviarArchivosTexto();
    }
       
    private void mostrarRecibirArchivoBinario(){
        mostrarRecibirArchivosTexto();   
    }
      
    public void aceptarCaracter(char caracter){
        if(estado==IDLE){
            if(caracter==SOH){
                estado=ESPERANDO_RECIBIR_ARCHIVO;
            }
            else{
                jTextPane1.setText(jTextPane1.getText()+String.valueOf(caracter));
            }
        }
        if(estado==RECIBIENDO_ARCHIVO){
            if(caracter==EOT){
                try{
                    bw.close();
                    fw.close();
                    estado=IDLE;
                }
                catch(java.io.IOException e){
                    System.out.println(e.getMessage());
                }
            }
            else{
                try{
                    bw.write(caracter);
                }
                catch(java.io.IOException e){
                    System.out.println(e.getMessage());
                }
            }
        }
        if(estado==ESPERANDO_TRANSMITIR_ARCHIVO && caracter==ACK){
            estado=TRANSMITIENDO_ARCHIVO;
            char c;
            int i;
            try{
                i=br.read();
                while(i!=-1){
                    c=(char)i;
                    uart.enviar(c);
                    i=br.read();
                }
                uart.enviar(EOT);
                estado=IDLE;
            }
            catch(java.io.IOException e){
                System.out.println(e.getMessage());
            }
        }
        
    }
    
    private void enviarCaracterDeArchivo(){
        try{
            char c=(char)br.read();
            if(c!=-1){
                uart.enviar((char)br.read());
            }
            else{
                uart.enviar(EOT);
                estado=IDLE;
                br.close();
                fr.close();
            }
        }
        catch(java.io.IOException e){
            System.out.println(e.getMessage());
        }
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        jMenuBarHyperTerminal = new javax.swing.JMenuBar();
        jMenuArchivo = new javax.swing.JMenu();
        jMenuItemNuevo = new javax.swing.JMenuItem();
        jMenuItemAbrir = new javax.swing.JMenuItem();
        jMenuItemGuardar = new javax.swing.JMenuItem();
        jMenuItemGuardarComo = new javax.swing.JMenuItem();
        jMenuItemEspecificarImpresora = new javax.swing.JMenuItem();
        jMenuItemSalir = new javax.swing.JMenuItem();
        jMenuEdicion = new javax.swing.JMenu();
        jMenuItemCopiar = new javax.swing.JMenuItem();
        jMenuItemPegar = new javax.swing.JMenuItem();
        jMenuItemEnviar = new javax.swing.JMenuItem();
        jMenuItemSeleccionarTodo = new javax.swing.JMenuItem();
        jMenuItemLimpiarBuffer = new javax.swing.JMenuItem();
        jMenuConfiguracion = new javax.swing.JMenu();
        jMenuItemNumTlfn = new javax.swing.JMenuItem();
        jMenuItemEmulaTreminal = new javax.swing.JMenuItem();
        jMenuItemPreferencias = new javax.swing.JMenuItem();
        jMenuItemTeclasFuncion = new javax.swing.JMenuItem();
        jMenuItemTransTexto = new javax.swing.JMenuItem();
        jMenuItemTransBinarias = new javax.swing.JMenuItem();
        jMenuItemComunicaciones = new javax.swing.JMenuItem();
        jMenuItemComModem = new javax.swing.JMenuItem();
        jMenuItemEcoImpresora = new javax.swing.JMenuItem();
        jMenuItemModoCronometro = new javax.swing.JMenuItem();
        jMenuItemMostrarTeclasFuncion = new javax.swing.JMenuItem();
        jMenuTelefono = new javax.swing.JMenu();
        jMenuItemMarcar = new javax.swing.JMenuItem();
        jMenuItemColgar = new javax.swing.JMenuItem();
        jMenuTransferencia = new javax.swing.JMenu();
        jMenuItemEnvArchTexto = new javax.swing.JMenuItem();
        jMenuItemRecArchTexto = new javax.swing.JMenuItem();
        jMenuItemVerArchTexto = new javax.swing.JMenuItem();
        jMenuItemEnvArchBinario = new javax.swing.JMenuItem();
        jMenuItemRecArchBinario = new javax.swing.JMenuItem();
        jMenuItemPausa = new javax.swing.JMenuItem();
        jMenuItemReanudar = new javax.swing.JMenuItem();
        jMenuItemDetener = new javax.swing.JMenuItem();
        jMenuAyuda = new javax.swing.JMenu();
        jMenuItemIndice = new javax.swing.JMenuItem();
        jMenuItemBuscarAyudaSobre = new javax.swing.JMenuItem();
        jMenuItemUsoAyuda = new javax.swing.JMenuItem();
        jMenuItemAcercaTerminal = new javax.swing.JMenuItem();

        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Hyper terminal");

        jTextPane1.setEditable(false);
        jTextPane1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTextPane1KeyPressed(evt);
            }
        });
        jScrollPane1.setViewportView(jTextPane1);

        jMenuArchivo.setText("Archivo");

        jMenuItemNuevo.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_N, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemNuevo.setBackground(new java.awt.Color(204, 204, 204));
        jMenuItemNuevo.setText("Nuevo");
        jMenuItemNuevo.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemNuevo.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        jMenuItemNuevo.setEnabled(false);
        jMenuArchivo.add(jMenuItemNuevo);

        jMenuItemAbrir.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemAbrir.setText("Abrir");
        jMenuItemAbrir.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemAbrir.setEnabled(false);
        jMenuArchivo.add(jMenuItemAbrir);

        jMenuItemGuardar.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_G, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemGuardar.setText("Guardar");
        jMenuItemGuardar.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemGuardar.setEnabled(false);
        jMenuArchivo.add(jMenuItemGuardar);

        jMenuItemGuardarComo.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemGuardarComo.setText("Guardar como ...");
        jMenuItemGuardarComo.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemGuardarComo.setEnabled(false);
        jMenuArchivo.add(jMenuItemGuardarComo);

        jMenuItemEspecificarImpresora.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_P, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemEspecificarImpresora.setText("Especificar impresora ...");
        jMenuItemEspecificarImpresora.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemEspecificarImpresora.setEnabled(false);
        jMenuArchivo.add(jMenuItemEspecificarImpresora);

        jMenuItemSalir.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Q, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemSalir.setText("Salir");
        jMenuItemSalir.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemSalir.setEnabled(false);
        jMenuArchivo.add(jMenuItemSalir);

        jMenuBarHyperTerminal.add(jMenuArchivo);

        jMenuEdicion.setText("Edición");

        jMenuItemCopiar.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemCopiar.setText("Copiar");
        jMenuItemCopiar.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemCopiar.setEnabled(false);
        jMenuEdicion.add(jMenuItemCopiar);

        jMenuItemPegar.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_V, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemPegar.setText("Pegar");
        jMenuItemPegar.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemPegar.setEnabled(false);
        jMenuEdicion.add(jMenuItemPegar);

        jMenuItemEnviar.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_INSERT, java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemEnviar.setText("Enviar");
        jMenuItemEnviar.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemEnviar.setEnabled(false);
        jMenuEdicion.add(jMenuItemEnviar);

        jMenuItemSeleccionarTodo.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_E, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemSeleccionarTodo.setText("Seleccionar todo");
        jMenuItemSeleccionarTodo.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemSeleccionarTodo.setEnabled(false);
        jMenuEdicion.add(jMenuItemSeleccionarTodo);

        jMenuItemLimpiarBuffer.setText("Limpiar búffer");
        jMenuItemLimpiarBuffer.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemLimpiarBuffer.setEnabled(false);
        jMenuEdicion.add(jMenuItemLimpiarBuffer);

        jMenuBarHyperTerminal.add(jMenuEdicion);

        jMenuConfiguracion.setText("Configuración");

        jMenuItemNumTlfn.setText("Número de Teléfono");
        jMenuItemNumTlfn.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemNumTlfn.setEnabled(false);
        jMenuConfiguracion.add(jMenuItemNumTlfn);

        jMenuItemEmulaTreminal.setText("Emulación de la Terminal");
        jMenuItemEmulaTreminal.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemEmulaTreminal.setEnabled(false);
        jMenuConfiguracion.add(jMenuItemEmulaTreminal);

        jMenuItemPreferencias.setText("Preferencia de la Terminal");
        jMenuItemPreferencias.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jMenuItemPreferencias.setBorderPainted(true);
        jMenuItemPreferencias.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jMenuItemPreferenciasMousePressed(evt);
            }
        });
        jMenuItemPreferencias.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemPreferenciasActionPerformed(evt);
            }
        });
        jMenuConfiguracion.add(jMenuItemPreferencias);

        jMenuItemTeclasFuncion.setText("Teclas de Función");
        jMenuItemTeclasFuncion.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemTeclasFuncion.setEnabled(false);
        jMenuConfiguracion.add(jMenuItemTeclasFuncion);

        jMenuItemTransTexto.setText("Transferencias de Texto");
        jMenuItemTransTexto.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemTransTexto.setEnabled(false);
        jMenuItemTransTexto.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jMenuItemTransTextoMousePressed(evt);
            }
        });
        jMenuItemTransTexto.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemTransTextoActionPerformed(evt);
            }
        });
        jMenuConfiguracion.add(jMenuItemTransTexto);

        jMenuItemTransBinarias.setText("Transferencias Binarias");
        jMenuItemTransBinarias.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemTransBinarias.setEnabled(false);
        jMenuItemTransBinarias.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jMenuItemTransBinariasMousePressed(evt);
            }
        });
        jMenuConfiguracion.add(jMenuItemTransBinarias);

        jMenuItemComunicaciones.setText("Comunicaciones");
        jMenuItemComunicaciones.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jMenuItemComunicaciones.setBorderPainted(true);
        jMenuItemComunicaciones.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jMenuItemComunicacionesMousePressed(evt);
            }
        });
        jMenuItemComunicaciones.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemComunicacionesActionPerformed(evt);
            }
        });
        jMenuConfiguracion.add(jMenuItemComunicaciones);

        jMenuItemComModem.setText("Comandos del Modem");
        jMenuItemComModem.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemComModem.setEnabled(false);
        jMenuConfiguracion.add(jMenuItemComModem);

        jMenuItemEcoImpresora.setText("Eco de la Impresora");
        jMenuItemEcoImpresora.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemEcoImpresora.setEnabled(false);
        jMenuConfiguracion.add(jMenuItemEcoImpresora);

        jMenuItemModoCronometro.setText("Modo del Cronómetro");
        jMenuItemModoCronometro.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemModoCronometro.setEnabled(false);
        jMenuConfiguracion.add(jMenuItemModoCronometro);

        jMenuItemMostrarTeclasFuncion.setText("Mostrar Teclas de Función");
        jMenuItemMostrarTeclasFuncion.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemMostrarTeclasFuncion.setEnabled(false);
        jMenuConfiguracion.add(jMenuItemMostrarTeclasFuncion);

        jMenuBarHyperTerminal.add(jMenuConfiguracion);

        jMenuTelefono.setText("Teléfono");

        jMenuItemMarcar.setText("Marcar");
        jMenuItemMarcar.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemMarcar.setEnabled(false);
        jMenuTelefono.add(jMenuItemMarcar);

        jMenuItemColgar.setText("Colgar");
        jMenuItemColgar.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemColgar.setEnabled(false);
        jMenuTelefono.add(jMenuItemColgar);

        jMenuBarHyperTerminal.add(jMenuTelefono);

        jMenuTransferencia.setText("Transferencia");

        jMenuItemEnvArchTexto.setText("Enviar archivo de texto ...");
        jMenuItemEnvArchTexto.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jMenuItemEnvArchTexto.setBorderPainted(true);
        jMenuItemEnvArchTexto.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jMenuItemEnvArchTextoMousePressed(evt);
            }
        });
        jMenuTransferencia.add(jMenuItemEnvArchTexto);

        jMenuItemRecArchTexto.setText("Recibir archivos de texto ...");
        jMenuItemRecArchTexto.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jMenuItemRecArchTexto.setBorderPainted(true);
        jMenuItemRecArchTexto.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jMenuItemRecArchTextoMousePressed(evt);
            }
        });
        jMenuTransferencia.add(jMenuItemRecArchTexto);

        jMenuItemVerArchTexto.setText("Ver archivo de texto ...");
        jMenuItemVerArchTexto.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemVerArchTexto.setEnabled(false);
        jMenuTransferencia.add(jMenuItemVerArchTexto);

        jMenuItemEnvArchBinario.setText("Enviar archivo binario ...");
        jMenuItemEnvArchBinario.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemEnvArchBinario.setEnabled(false);
        jMenuItemEnvArchBinario.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jMenuItemEnvArchBinarioMousePressed(evt);
            }
        });
        jMenuTransferencia.add(jMenuItemEnvArchBinario);

        jMenuItemRecArchBinario.setText("Recibir archivo binario ...");
        jMenuItemRecArchBinario.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemRecArchBinario.setEnabled(false);
        jMenuItemRecArchBinario.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jMenuItemRecArchBinarioMousePressed(evt);
            }
        });
        jMenuTransferencia.add(jMenuItemRecArchBinario);

        jMenuItemPausa.setText("Pausa");
        jMenuItemPausa.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemPausa.setEnabled(false);
        jMenuTransferencia.add(jMenuItemPausa);

        jMenuItemReanudar.setText("Reanudar");
        jMenuItemReanudar.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemReanudar.setEnabled(false);
        jMenuTransferencia.add(jMenuItemReanudar);

        jMenuItemDetener.setText("Detener");
        jMenuItemDetener.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemDetener.setEnabled(false);
        jMenuTransferencia.add(jMenuItemDetener);

        jMenuBarHyperTerminal.add(jMenuTransferencia);

        jMenuAyuda.setText("Ayuda");

        jMenuItemIndice.setText("Indice");
        jMenuItemIndice.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemIndice.setEnabled(false);
        jMenuAyuda.add(jMenuItemIndice);

        jMenuItemBuscarAyudaSobre.setText("Buscar ayuda sobre ...");
        jMenuItemBuscarAyudaSobre.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemBuscarAyudaSobre.setEnabled(false);
        jMenuAyuda.add(jMenuItemBuscarAyudaSobre);

        jMenuItemUsoAyuda.setText("Uso de la ayuda ...");
        jMenuItemUsoAyuda.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jMenuItemUsoAyuda.setEnabled(false);
        jMenuAyuda.add(jMenuItemUsoAyuda);

        jMenuItemAcercaTerminal.setText("Acerca de terminal ...");
        jMenuItemAcercaTerminal.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jMenuItemAcercaTerminal.setBorderPainted(true);
        jMenuAyuda.add(jMenuItemAcercaTerminal);

        jMenuBarHyperTerminal.add(jMenuAyuda);

        setJMenuBar(jMenuBarHyperTerminal);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 480, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 277, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItemComunicacionesMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuItemComunicacionesMousePressed
        Comunicaciones com=new Comunicaciones(null,true,this);
        com.setVisible(true);
    }//GEN-LAST:event_jMenuItemComunicacionesMousePressed

    private void jMenuItemComunicacionesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemComunicacionesActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jMenuItemComunicacionesActionPerformed

    private void jMenuItemPreferenciasActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemPreferenciasActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jMenuItemPreferenciasActionPerformed

    private void jMenuItemPreferenciasMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuItemPreferenciasMousePressed
        // TODO add your handling code here:
        PreferenciasTerminal pref=new PreferenciasTerminal(null,true);
        pref.inicializar(this);
        pref.setVisible(true);
        this.ecoLocal=pref.ecoLocal;
        if(ecoLocal){
            jTextPane1.setEditable(true);
        }
        else{
            jTextPane1.setEditable(false);
        }
    }//GEN-LAST:event_jMenuItemPreferenciasMousePressed

    private void jMenuItemTransTextoMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuItemTransTextoMousePressed
        
    }//GEN-LAST:event_jMenuItemTransTextoMousePressed

    private void jMenuItemTransTextoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemTransTextoActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jMenuItemTransTextoActionPerformed

    private void jMenuItemTransBinariasMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuItemTransBinariasMousePressed
        
    }//GEN-LAST:event_jMenuItemTransBinariasMousePressed

    private void jTextPane1KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextPane1KeyPressed
        uart.enviar(evt.getKeyChar());
    }//GEN-LAST:event_jTextPane1KeyPressed

    private void jMenuItemEnvArchTextoMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuItemEnvArchTextoMousePressed
        mostrarEnviarArchivosTexto();
    }//GEN-LAST:event_jMenuItemEnvArchTextoMousePressed

    private void jMenuItemRecArchTextoMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuItemRecArchTextoMousePressed
       mostrarRecibirArchivosTexto();
    }//GEN-LAST:event_jMenuItemRecArchTextoMousePressed

    private void jMenuItemRecArchBinarioMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuItemRecArchBinarioMousePressed
        
    }//GEN-LAST:event_jMenuItemRecArchBinarioMousePressed

    private void jMenuItemEnvArchBinarioMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuItemEnvArchBinarioMousePressed
        
    }//GEN-LAST:event_jMenuItemEnvArchBinarioMousePressed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenu jMenuArchivo;
    private javax.swing.JMenu jMenuAyuda;
    private javax.swing.JMenuBar jMenuBarHyperTerminal;
    private javax.swing.JMenu jMenuConfiguracion;
    private javax.swing.JMenu jMenuEdicion;
    private javax.swing.JMenuItem jMenuItemAbrir;
    private javax.swing.JMenuItem jMenuItemAcercaTerminal;
    private javax.swing.JMenuItem jMenuItemBuscarAyudaSobre;
    private javax.swing.JMenuItem jMenuItemColgar;
    private javax.swing.JMenuItem jMenuItemComModem;
    private javax.swing.JMenuItem jMenuItemComunicaciones;
    private javax.swing.JMenuItem jMenuItemCopiar;
    private javax.swing.JMenuItem jMenuItemDetener;
    private javax.swing.JMenuItem jMenuItemEcoImpresora;
    private javax.swing.JMenuItem jMenuItemEmulaTreminal;
    private javax.swing.JMenuItem jMenuItemEnvArchBinario;
    private javax.swing.JMenuItem jMenuItemEnvArchTexto;
    private javax.swing.JMenuItem jMenuItemEnviar;
    private javax.swing.JMenuItem jMenuItemEspecificarImpresora;
    private javax.swing.JMenuItem jMenuItemGuardar;
    private javax.swing.JMenuItem jMenuItemGuardarComo;
    private javax.swing.JMenuItem jMenuItemIndice;
    private javax.swing.JMenuItem jMenuItemLimpiarBuffer;
    private javax.swing.JMenuItem jMenuItemMarcar;
    private javax.swing.JMenuItem jMenuItemModoCronometro;
    private javax.swing.JMenuItem jMenuItemMostrarTeclasFuncion;
    private javax.swing.JMenuItem jMenuItemNuevo;
    private javax.swing.JMenuItem jMenuItemNumTlfn;
    private javax.swing.JMenuItem jMenuItemPausa;
    private javax.swing.JMenuItem jMenuItemPegar;
    private javax.swing.JMenuItem jMenuItemPreferencias;
    private javax.swing.JMenuItem jMenuItemReanudar;
    private javax.swing.JMenuItem jMenuItemRecArchBinario;
    private javax.swing.JMenuItem jMenuItemRecArchTexto;
    private javax.swing.JMenuItem jMenuItemSalir;
    private javax.swing.JMenuItem jMenuItemSeleccionarTodo;
    private javax.swing.JMenuItem jMenuItemTeclasFuncion;
    private javax.swing.JMenuItem jMenuItemTransBinarias;
    private javax.swing.JMenuItem jMenuItemTransTexto;
    private javax.swing.JMenuItem jMenuItemUsoAyuda;
    private javax.swing.JMenuItem jMenuItemVerArchTexto;
    private javax.swing.JMenu jMenuTelefono;
    private javax.swing.JMenu jMenuTransferencia;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextPane jTextPane1;
    // End of variables declaration//GEN-END:variables
}
