/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * PantallaOsciloscopio.java
 *
 * Created on 15-oct-2011, 11:41:48
 */
package rs232;

/**
 *
 * @author Jorge
 */

import java.awt.Graphics;
import java.awt.Color;

public class PantallaOsciloscopio extends javax.swing.JPanel {
    
    private static int LONGITUD_BIT_DEFECTO=10;
    private static double TENSION_POR_DEFECTO=5;
    
    private int ANCHO;//ancho del panel
    private int ALTO;//alto del panel
    private int DIST_RAYITAS;//distancia entre rayitas por defecto
    private int EJEX;//posicion vertical del eje X
    private boolean senal[]=new boolean[0];//senal recibida mostrandose
    private int velocidad=9600;//velocidad por defecto
    private double tensionEntreRayitas=1;
    private int desplazamientoVertical=0;
    private int desplazamientoHorizontal=0;
    private int pHoriz=50;//poercentaje de desplazamiento horizontal
    private int pVert=0;//poercentaje de desplazamiento vertical
    private double escaladoX=1.0; //lo que se estira la senal en el sentido x
    
    
    /** Creates new form PantallaOsciloscopio */
    public PantallaOsciloscopio() {
        initComponents();
        
        
        //senal a 1 logico por defecto
        senal=new boolean[24];
        for(int i=0;i<24;i++){
            senal[i]=true;
        }
        
    }

    public void paintComponent(Graphics g){
        this.ANCHO=this.getWidth();
        this.ALTO=this.getHeight();
        this.DIST_RAYITAS=2;
        this.EJEX=ALTO/2;
        desplazamientoHorizontal=(ANCHO*pHoriz)/100;//desplazamiento Horizontal en pixels
        desplazamientoVertical=(ALTO*pVert)/100;//desplazamiento Vertical en pixels
        double factorx=9600.0/((double)velocidad);//factor de estiramiento horizontal de la senal dependiendo de la velocidad de la transmision
        
        int i;
        int x,y;
        
        // Dibujamos los ejes y la graduacion de los mismos
        y=0;
        x=0;
        //Fondo
        Color color=new java.awt.Color(128,128,255);
        g.setColor(color);
        g.fillRect(0, 0,ANCHO , ALTO);
        g.setColor(Color.BLACK);
        //Ejes
        g.drawLine(0, ALTO/2, ANCHO, ALTO/2);
        g.drawLine(ANCHO/2,0,ANCHO/2,ALTO);
        
        //Rayitas de la graduciaon
        for(i=0;i<ANCHO/2;i=i+DIST_RAYITAS){
            g.drawLine(ANCHO/2+DIST_RAYITAS*i, ALTO/2-3, ANCHO/2+DIST_RAYITAS*i, ALTO/2+3);
            g.drawLine(ANCHO/2-DIST_RAYITAS*i, ALTO/2-3, ANCHO/2-DIST_RAYITAS*i, ALTO/2+3);
            if(i%5==0){
                g.drawLine(ANCHO/2+DIST_RAYITAS*i,0, ANCHO/2+DIST_RAYITAS*i, ALTO);
                g.drawLine(ANCHO/2-DIST_RAYITAS*i,0, ANCHO/2-DIST_RAYITAS*i, ALTO);
            }
        }
        
        for(i=0;i<ALTO/2;i=i+DIST_RAYITAS){
            g.drawLine(ANCHO/2-3, ALTO/2+DIST_RAYITAS*i, ANCHO/2+3, ALTO/2+DIST_RAYITAS*i);
            g.drawLine(ANCHO/2-3, ALTO/2-DIST_RAYITAS*i, ANCHO/2+3, ALTO/2-DIST_RAYITAS*i);
            if(i%5==0){
                g.drawLine(0, ALTO/2+DIST_RAYITAS*i, ANCHO, ALTO/2+DIST_RAYITAS*i);
                g.drawLine(0, ALTO/2-DIST_RAYITAS*i, ANCHO, ALTO/2-DIST_RAYITAS*i);
            }
        }
        
        color = new Color(140,255,255);
        g.setColor(color);
        
        //Dibujamos la linea que precede a la senal
        g.drawLine(0,EJEX+desplazamientoVertical+2*DIST_RAYITAS*(int)(TENSION_POR_DEFECTO/tensionEntreRayitas),desplazamientoHorizontal,EJEX+desplazamientoVertical+2*DIST_RAYITAS*(int)(TENSION_POR_DEFECTO/tensionEntreRayitas));
        //Dibujar la linea vertical que une la senal por defecto con el inicio de la senal
        if(!senal[0]){
            g.drawLine(desplazamientoHorizontal,EJEX+desplazamientoVertical+2*DIST_RAYITAS*(int)(TENSION_POR_DEFECTO/tensionEntreRayitas),desplazamientoHorizontal,EJEX+desplazamientoVertical-2*DIST_RAYITAS*(int)(TENSION_POR_DEFECTO/tensionEntreRayitas));
        }
        //Dibujar la senal
        for(i=0;i<senal.length;i++){
            x=i*(int)(((double)LONGITUD_BIT_DEFECTO*factorx*escaladoX));
            if(senal[i]){
                y=+2*DIST_RAYITAS*(int)(TENSION_POR_DEFECTO/tensionEntreRayitas);
            }
            else{
                y=-2*DIST_RAYITAS*(int)(TENSION_POR_DEFECTO/tensionEntreRayitas);
            }
            g.drawLine(desplazamientoHorizontal+x, desplazamientoVertical+y+EJEX, desplazamientoHorizontal+x+(int)(((double)LONGITUD_BIT_DEFECTO*factorx*escaladoX)), desplazamientoVertical+y+EJEX);
            if(i>0 && senal[i-1]!=senal[i]){
                g.drawLine(desplazamientoHorizontal+x, desplazamientoVertical+y+EJEX, desplazamientoHorizontal+x, desplazamientoVertical-y+EJEX);
            }
        }
        //dibujar la linea vertical que una el final de la senal con la senal por defecto
        if(!senal[i-1]){
            x=i*LONGITUD_BIT_DEFECTO*(int)(((double)LONGITUD_BIT_DEFECTO*factorx*escaladoX));
            g.drawLine(desplazamientoHorizontal+x, desplazamientoVertical+y+EJEX, desplazamientoHorizontal+x, desplazamientoVertical-y+EJEX);
        }
        //Dibujar senal por defecto despues de la senal
        g.drawLine(desplazamientoHorizontal+x,EJEX+desplazamientoVertical+2*DIST_RAYITAS*(int)(TENSION_POR_DEFECTO/tensionEntreRayitas),ANCHO,EJEX+desplazamientoVertical+2*DIST_RAYITAS*(int)(TENSION_POR_DEFECTO/tensionEntreRayitas));
    }
    
    public void setSenal(int velocidad,boolean[] senal){
        this.senal=senal;
        this.velocidad=velocidad;
        this.repaint();
    }
    
   
    
    public void setTensionEntreRayas(double tension){
        tensionEntreRayitas=tension/5;
        repaint();
    }
    
    public void setDesplazamientoHorizontal(int p){
        pHoriz=p;
        repaint();
    }
    public void setDesplazamientoVertical(int p){
        pVert=p-50;
        repaint();
    }
    
    public void incrementarEscaladoX(){
        escaladoX=escaladoX*1.2;
        repaint();
    }
    public void decrementarEscaladoX(){
        escaladoX=escaladoX/1.2;
        repaint();
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
