
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package rs232;
/**
 *
 * @author Jorge
 */

public class UART {
    static int PARIDAD_NINGUNA=0;
    static int PARIDAD_PAR=1;
    static int PARIDAD_IMPAR=2;
    static int PARIDAD_MARCA=3;
    static int PARIDAD_ESPACIO=4;
    
    boolean ctrl_flujo=false; //-------------------> False se refiere al modo X-Modem y si es true para Null-Modem
    
    public int velocidad=9600;
    public int bitsDatos=8;
    public double bitsParo=1.0;
    public int paridad ;
    
    private char caracterRecibido;
    private char caracterEnviado;
    
    private boolean errorEnRecepcion=false;
    
    private PODRS232 pod;
    private HyperTerminal hyperTerminal;
    
    public UART(PODRS232 pod,HyperTerminal hyperTerminal){
        this.pod=pod;
        this.hyperTerminal=hyperTerminal;
    }

    public void enviar(char caracter){
        caracterEnviado=caracter;

        boolean[] senal=new boolean[24];
        boolean[] senalDefinitiva;
        for(int i=0;i<24;i++){
            senal[i]=false;
        }

        int ascii=(int)caracter;
        senal[0]=false;
        senal[1]=false;
        int nBits=0;
        int n=2;
        for(int i=0;i<bitsDatos;i++){
            senal[n]=(ascii%2==1);
            senal[n+1]=(ascii%2==1);
            nBits=nBits+ascii%2;
            ascii=ascii/2;
            n=n+2;
        }

        if(paridad==PARIDAD_PAR){
            senal[n]=nBits%2==1;
            senal[n+1]=nBits%2==1;
            n=n+2;
        }
        if(paridad==PARIDAD_IMPAR){
            senal[n]=nBits%2==0;
            senal[n+1]=nBits%2==0;
            n=n+2;
        }

        if(paridad==PARIDAD_MARCA){
            senal[n]=true;
            senal[n+1]=true;
            n=n+2;
        }
        if(paridad==PARIDAD_ESPACIO){
            senal[n]=false;
            senal[n+1]=false;
            n=n+2;
        }
        if(bitsParo==1.0){
            senal[n]=true;
            senal[n+1]=true;
            n=n+2;
        }
        if(bitsParo==1.5){
            senal[n]=true;
            senal[n+1]=true;
            senal[n+2]=true;
            senal[n+3]=true;
            n=n+4;
        }
        if(bitsParo==2.0){
            senal[n]=true;
            senal[n+1]=true;
            senal[n+2]=true;
            senal[n+3]=true;
            n=n+4;
        }
        senalDefinitiva=new boolean[n];
        for(int i=0;i<n;i++){
            senalDefinitiva[i]=senal[i];
        }
        pod.aceptarSenal(this,velocidad,senalDefinitiva);

    }

    public void aceptarSenal(int velocidad,boolean[] senal){
        errorEnRecepcion=false;
        if(this.velocidad==velocidad){
            int ascii=0;
            int nBits=0;
            int orden=1;
            int n=2;
            for(int i=0;i<bitsDatos;i++){
                if(senal[n+1]){
                    ascii=ascii+orden;
                    nBits++;
                }
                orden=orden*2;
                n=n+2;
            }
            if(paridad==PARIDAD_PAR || paridad==PARIDAD_IMPAR){
                if(senal[n]){
                    nBits++;
                    n=n+2;
                }
            }

            if(paridad==PARIDAD_PAR){
                if(nBits%2!=0){
                    errorEnRecepcion=true;
                }
            }
            if(paridad==PARIDAD_IMPAR){
                if(nBits%2!=1){
                    errorEnRecepcion=true;
                }
            }
            if(paridad==PARIDAD_MARCA){
                if(!senal[n-2]){
                    errorEnRecepcion=true;
                }
            }
            if(paridad==PARIDAD_ESPACIO){
                if(senal[n-2]){
                    errorEnRecepcion=true;
                }
            }

            if(bitsParo==1.0){
                if(!senal[n] || !senal[n+1]){
                    errorEnRecepcion=true;
                }
                n=n+2;
            }
            if(bitsParo==1.5){
                if(!senal[n] || !senal[n+1] || !senal[n+2]){
                    errorEnRecepcion=true;
                }
                n=n+3;
            }
            if(bitsParo==2.0){
                if(!senal[n] || !senal[n+1] || !senal[n+2] || !senal[n+2]){
                    errorEnRecepcion=true;
                }
                n=n+4;
            }
            if(!errorEnRecepcion){
                caracterRecibido=(char)ascii;
                hyperTerminal.aceptarCaracter(caracterRecibido);
            }
        }
        else{
            errorEnRecepcion=true;
        }
    }

    public void setVelocidad(int velocidad){
        this.velocidad=velocidad;
        pod.setPeriodo(1.0/(double)velocidad);
    }
}